require 'cabal/api/common/services'

module Cabal
  module API
    module Common
      module Authenticated
        def self.included(base)
          base.class_eval do
            include Cabal::API::Common::Services

            helpers do
              def current_user
                authorization = headers['Authorization'].to_s
                access_key, signature = authorization.split(':')

                user = user_service.by_access_key(access_key)

                if user && user.authenticated_with?(signature)
                  user
                else
                  nil
                end
              end

              def authenticate!
                error!({message: 'Unauthorized.'}, 401) unless current_user
              end
            end
          end
        end
      end
    end
  end
end
