require 'cabal/util'
require 'cabal/api'
require 'cabal/api/common/services'

module Cabal
  module API
    module Common
      module PublicKey
        def self.included(base)
          base.class_eval do
            include Cabal::API::Common::Services

            formatter :txt, ->(object, env) {
              object[:public_ssh_key]
            }

            get '/key/:name' do
              name = Cabal::Util.normalize(params[:name])
              cluster_service.create(name) unless cluster_service.names.include?(name)
              key = cluster_service.public_key(name)
              
              {
                name: name,
                public_ssh_key: key
              }
            end
          end
        end
      end
    end
  end
end
