require 'cabal/api'

module Cabal
  module API
    module Common
      module Services
        def self.included(base)
          base.class_eval do
            helpers do
              def cluster_service
                @cluster_service ||= ClusterService.new(
                  public_warehouse: STORAGE[:public],
                  private_warehouse: STORAGE[:private]
                )
              end

              def user_service
                @user_service ||= UserService.new(
                  user_warehouse: STORAGE[:users],
                  access_key_warehouse: STORAGE[:access_keys],
                  secret_key_warehouse: STORAGE[:secret_keys]
                )
              end
            end
          end
        end
      end
    end
  end
end
