require 'grape'
require 'cabal/util'
require 'cabal/api/cluster_service'
require 'cabal/api/user'
require 'cabal/api/common/authenticated'
require 'cabal/api/common/mistakes'

module Cabal
  module API
    module V3
      class List < Grape::API
        include Cabal::API::Common::Authenticated
        include Cabal::API::Common::Mistakes

        formatter :txt, ->(object, env) {
          object.map {|cluster| cluster[:name]}.join("\n")
        }

        get '/clusters' do
          authenticate!

          clusters = Cabal::API::ClusterService.new
          clusters.names.sort.map {|name| {name: name}}
        end
      end
    end
  end
end
